/*	Copyright 1993,94 H.Ogasawara (COR.)	*/

#include	"config.h"

#if HUMAN68K
#  if SYSDOSLIB
#    include	<sys_doslib.h>
#  else
#    include	<doslib.h>
#  endif
#endif

#define	NAMES	(PATHLEN*2+NAMELEN*2)

typedef struct {
		unsigned int	(*exec)();
		unsigned int	fsize,		/* file size counter */
				byte,		/* byte length of line */
				body,		/* data length of line */
				blockbyte,	/* block size */
				code,
				dline,
				cline,
				nextline,
				stepline,
				initflag,
				vol,
				volsize,
				mode,
				date,
				tcrc32;
		int		block;		/* total block counter */
		unsigned short	tcrc;
		short		perm,
				os;
		unsigned char	*sf_tbl;
		unsigned char	fname[PATHLEN],
				adjname[NAMELEN],
				outname[PATHLEN],
				skipname[NAMELEN];
	} T_HD;

#define	FALSE	0
#define	TRUE	1
#define	EOISH	2

#define	CODE7	13
#define	CODE8	8
#define	CODEN	14
#define	CODES	15
#define	UUE	0xff

#define	DBUF	80

#define	mNOTSUM		1
#define	mPRTOUT		2
#define	mADJNAME	4
#define	mOUTPUT		8
#define	mAPPEND		16
#define	mLIST		32
#define	mSKIP		64
#define	mUUENC		128
#define	mUUCHK		128

